#include <stddef.h>
#include <stdint.h>
#include <stdio.h>

//// STRUCT DEFNS

#define STRUCT_NAME GoodStruct1
#define STRUCT_FIELDS 		\
  X(uint32_t,	int1) 		\
  X(uint32_t,	int2)
#include "gen_struct_fmt.h"

#define STRUCT_NAME GoodStruct2
#define STRUCT_FIELDS 		\
  X(uint32_t,	int1) 		\
  X(uint32_t,	int2) 		\
  X(void*,	ptr_data)
#include "gen_struct_fmt.h"

#define STRUCT_NAME GoodStruct3
#define STRUCT_FIELDS 		\
  X(void*,	ptr_data) 	\
  X(uint32_t,	int1) 		\
  X(uint32_t,	int2)
#include "gen_struct_fmt.h"

#define STRUCT_NAME BadStruct
#define STRUCT_FIELDS 		\
  X(void*,	ptr_data1) 	\
  X(void*,	ptr_data2) 	\
  X(uint32_t,	int1) 		\
  X(uint32_t,	int2)
#include "gen_struct_fmt.h"


//// SUPPORT FUNCTIONS

void print_buffer(unsigned char *buffer, size_t size) {
    for (size_t j = 0; j < size; j++) {
        printf(" %02x", buffer[j]);
    }
}

void print_struct(struct struct_fmt *fmt, void *structure) {
    printf("%s:\n", fmt->struct_name);
    for (size_t i = 0; i < fmt->num_members; i++) {
        printf("\t%s:   \t%02zu %zu ",
               fmt->names[i],
               (fmt->offsets[i]) +1, //Pharo one-based offset
               (fmt->sizes[i]));
	if(structure) {
		printf("=");
        	print_buffer(((unsigned char*)structure)+fmt->offsets[i],
                     fmt->sizes[i]);
	}
        printf("\n");
    }
}


//// PHARO TEST FRAME

int tryBad(struct BadStruct aStruct)
{    	print_struct(&BadStruct_fmt, &aStruct);
	return aStruct.int1 * aStruct.int2; 
}

int tryGood1(struct GoodStruct1 aStruct)
{   	print_struct(&GoodStruct1_fmt, &aStruct);
	return aStruct.int1 * aStruct.int2; 
}

int tryGood2(struct GoodStruct2 aStruct)
{	print_struct(&GoodStruct2_fmt, &aStruct);
    	return aStruct.int1 * aStruct.int2; 
}

int tryGood3(struct GoodStruct3 aStruct)
{	print_struct(&GoodStruct3_fmt, &aStruct);
    	return aStruct.int1 * aStruct.int2; 
}


int main()
{   	// Display struct layout 
	print_struct(&GoodStruct1_fmt, 		0);
	print_struct(&GoodStruct2_fmt, 		0);
	print_struct(&GoodStruct3_fmt, 		0);
	print_struct(&BadStruct_fmt, 		0);
}

